dnl # 6.12-rc4 API change
dnl #
dnl # 6.12-rc4 commit 56440d7ec28d ("genetlink: hold RCU in genlmsg_mcast()")
dnl # will now hold RCU in genlmsg_mcast() in its inner calls, and the last gfp
dnl # flag argument was therefore removed.
dnl #
AC_DEFUN([ZFS_AC_KERNEL_GENLMSG_MCAST_ALLNS], [
	AC_MSG_CHECKING([whether genlmsg_multicast_allns exists])
	ZFS_CHECK_SYMBOL_EXPORT([genlmsg_multicast_allns], [], [
		AC_MSG_RESULT(yes)
		AC_DEFINE(BACKPORT_HAVE_GENLMSG_MCAST_ALLNS, 1,
			[genlmsg_multicast_allns exists])

		AC_MSG_CHECKING([whether genlmsg_multicast_allns takes a gfp flag])
		ZFS_LINUX_TRY_COMPILE([
			#include <net/genetlink.h>
		], [
			struct genl_family nl80211_fam = {};
			struct sk_buff *msg = NULL;

			genlmsg_multicast_allns(&nl80211_fam, msg, 0, 0, GFP_ATOMIC);
		], [
			AC_MSG_RESULT(yes)
		], [
			ZFS_LINUX_TRY_COMPILE([
				#include <net/genetlink.h>
			], [
				struct genl_family nl80211_fam = {};
				struct sk_buff *msg = NULL;

				genlmsg_multicast_allns(&nl80211_fam, msg, 0, 0);
			], [
				AC_MSG_RESULT(no)
				AC_DEFINE(BACKPORT_HAVE_GENLMSG_MCAST_ALLNS__NO_GFP, 1,
					[genlmsg_multicast_allns takes no additional gfp flag])
			], [
				ZFS_LINUX_TEST_ERROR([genlmsg_multicast_allns])
			])
		])
	], [
		AC_MSG_RESULT(no)
	])
])
